/**
 * Returns an array of 2 objects,
 * first, the result of calling `_.pick`,
 * second, the result of calling `_.omit`
 *
 * e.g.
 * ```js
 * const obj = { a: 'A', b: 'B', c: 'C', d: 'D' }
 * pickAndOmit(obj, ['a', 'b']) // [{a: "A", b: "B"}, {c: "C", d: "D"}]
 * ```
 */
export declare const pickAndOmit: <T extends object, K extends keyof T>(object: T, keys: K[]) => [Pick<T, K>, Omit<T, K>];
//# sourceMappingURL=index.d.ts.map